/* keymap.c generated by valac 0.39.7, the Vala compiler
 * generated from keymap.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 4 -*-
 * -*- coding: utf-8 -*-
 *
 * Copyright (C) 2011 ~ 2017 Deepin, Inc.
 *               2011 ~ 2017 Wang Yong
 *
 * Author:     Wang Yong <wangyong@deepin.com>
 * Maintainer: Wang Yong <wangyong@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>

#define _g_free0(var) (var = (g_free (var), NULL))



gchar* keymap_get_keyevent_name (GdkEventKey* key_event);
gchar** keymap_get_key_event_modifiers (GdkEventKey* key_event,
                                        int* result_length1);
gchar* keymap_get_key_name (guint keyval);
static void _vala_array_add1 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static void _vala_array_add2 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static void _vala_array_add3 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static void _vala_array_add4 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static void _vala_array_add5 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
gboolean keymap_has_ctrl_mask (GdkEventKey* key_event);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      int stack_length,
                                      gchar* needle);
gboolean keymap_has_shift_mask (GdkEventKey* key_event);
gboolean keymap_is_no_key_press (GdkEventKey* key_event);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);


gchar*
keymap_get_keyevent_name (GdkEventKey* key_event)
{
	gchar* result = NULL;
	guint _tmp0_;
	g_return_val_if_fail (key_event != NULL, NULL);
	_tmp0_ = key_event->is_modifier;
	if (_tmp0_ != ((guint) 0)) {
		gchar* _tmp1_;
		_tmp1_ = g_strdup ("");
		result = _tmp1_;
		return result;
	} else {
		gchar** key_modifiers = NULL;
		gint _tmp2_;
		gchar** _tmp3_;
		gint key_modifiers_length1;
		gint _key_modifiers_size_;
		gchar* key_name = NULL;
		guint _tmp4_;
		gchar* _tmp5_;
		gchar** _tmp6_;
		gint _tmp6__length1;
		_tmp3_ = keymap_get_key_event_modifiers (key_event, &_tmp2_);
		key_modifiers = _tmp3_;
		key_modifiers_length1 = _tmp2_;
		_key_modifiers_size_ = key_modifiers_length1;
		_tmp4_ = key_event->keyval;
		_tmp5_ = keymap_get_key_name (_tmp4_);
		key_name = _tmp5_;
		_tmp6_ = key_modifiers;
		_tmp6__length1 = key_modifiers_length1;
		if (_tmp6__length1 == 0) {
			result = key_name;
			key_modifiers = (_vala_array_free (key_modifiers, key_modifiers_length1, (GDestroyNotify) g_free), NULL);
			return result;
		} else {
			gchar* name = NULL;
			gchar* _tmp7_;
			gchar** _tmp8_;
			gint _tmp8__length1;
			const gchar* _tmp15_;
			const gchar* _tmp16_;
			gchar* _tmp17_;
			_tmp7_ = g_strdup ("");
			name = _tmp7_;
			_tmp8_ = key_modifiers;
			_tmp8__length1 = key_modifiers_length1;
			{
				gchar** modifier_collection = NULL;
				gint modifier_collection_length1 = 0;
				gint _modifier_collection_size_ = 0;
				gint modifier_it = 0;
				modifier_collection = _tmp8_;
				modifier_collection_length1 = _tmp8__length1;
				for (modifier_it = 0; modifier_it < _tmp8__length1; modifier_it = modifier_it + 1) {
					gchar* _tmp9_;
					gchar* modifier = NULL;
					_tmp9_ = g_strdup (modifier_collection[modifier_it]);
					modifier = _tmp9_;
					{
						const gchar* _tmp10_;
						const gchar* _tmp11_;
						gchar* _tmp12_;
						gchar* _tmp13_;
						gchar* _tmp14_;
						_tmp10_ = name;
						_tmp11_ = modifier;
						_tmp12_ = g_strconcat (_tmp11_, " + ", NULL);
						_tmp13_ = _tmp12_;
						_tmp14_ = g_strconcat (_tmp10_, _tmp13_, NULL);
						_g_free0 (name);
						name = _tmp14_;
						_g_free0 (_tmp13_);
						_g_free0 (modifier);
					}
				}
			}
			_tmp15_ = name;
			_tmp16_ = key_name;
			_tmp17_ = g_strconcat (_tmp15_, _tmp16_, NULL);
			_g_free0 (name);
			name = _tmp17_;
			result = name;
			_g_free0 (key_name);
			key_modifiers = (_vala_array_free (key_modifiers, key_modifiers_length1, (GDestroyNotify) g_free), NULL);
			return result;
		}
		_g_free0 (key_name);
		key_modifiers = (_vala_array_free (key_modifiers, key_modifiers_length1, (GDestroyNotify) g_free), NULL);
	}
}


static void
_vala_array_add1 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void
_vala_array_add2 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void
_vala_array_add3 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void
_vala_array_add4 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void
_vala_array_add5 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


gchar**
keymap_get_key_event_modifiers (GdkEventKey* key_event,
                                int* result_length1)
{
	gchar** result = NULL;
	gchar** modifiers = NULL;
	gchar** _tmp0_;
	gint modifiers_length1;
	gint _modifiers_size_;
	GdkModifierType _tmp1_;
	GdkModifierType _tmp4_;
	GdkModifierType _tmp7_;
	GdkModifierType _tmp10_;
	GdkModifierType _tmp13_;
	gchar** _tmp16_;
	gint _tmp16__length1;
	g_return_val_if_fail (key_event != NULL, NULL);
	_tmp0_ = g_new0 (gchar*, 0 + 1);
	modifiers = _tmp0_;
	modifiers_length1 = 0;
	_modifiers_size_ = modifiers_length1;
	_tmp1_ = key_event->state;
	if ((_tmp1_ & GDK_CONTROL_MASK) != 0) {
		gchar** _tmp2_;
		gint _tmp2__length1;
		gchar* _tmp3_;
		_tmp2_ = modifiers;
		_tmp2__length1 = modifiers_length1;
		_tmp3_ = g_strdup ("Ctrl");
		_vala_array_add1 (&modifiers, &modifiers_length1, &_modifiers_size_, _tmp3_);
	}
	_tmp4_ = key_event->state;
	if ((_tmp4_ & GDK_SUPER_MASK) != 0) {
		gchar** _tmp5_;
		gint _tmp5__length1;
		gchar* _tmp6_;
		_tmp5_ = modifiers;
		_tmp5__length1 = modifiers_length1;
		_tmp6_ = g_strdup ("Super");
		_vala_array_add2 (&modifiers, &modifiers_length1, &_modifiers_size_, _tmp6_);
	}
	_tmp7_ = key_event->state;
	if ((_tmp7_ & GDK_HYPER_MASK) != 0) {
		gchar** _tmp8_;
		gint _tmp8__length1;
		gchar* _tmp9_;
		_tmp8_ = modifiers;
		_tmp8__length1 = modifiers_length1;
		_tmp9_ = g_strdup ("Hyper");
		_vala_array_add3 (&modifiers, &modifiers_length1, &_modifiers_size_, _tmp9_);
	}
	_tmp10_ = key_event->state;
	if ((_tmp10_ & GDK_MOD1_MASK) != 0) {
		gchar** _tmp11_;
		gint _tmp11__length1;
		gchar* _tmp12_;
		_tmp11_ = modifiers;
		_tmp11__length1 = modifiers_length1;
		_tmp12_ = g_strdup ("Alt");
		_vala_array_add4 (&modifiers, &modifiers_length1, &_modifiers_size_, _tmp12_);
	}
	_tmp13_ = key_event->state;
	if ((_tmp13_ & GDK_SHIFT_MASK) != 0) {
		gchar** _tmp14_;
		gint _tmp14__length1;
		gchar* _tmp15_;
		_tmp14_ = modifiers;
		_tmp14__length1 = modifiers_length1;
		_tmp15_ = g_strdup ("Shift");
		_vala_array_add5 (&modifiers, &modifiers_length1, &_modifiers_size_, _tmp15_);
	}
	_tmp16_ = modifiers;
	_tmp16__length1 = modifiers_length1;
	if (result_length1) {
		*result_length1 = _tmp16__length1;
	}
	result = _tmp16_;
	return result;
}


static gchar*
g_unichar_to_string (gunichar self)
{
	gchar* result = NULL;
	gchar* str = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	_tmp0_ = g_new0 (gchar, 7);
	str = (gchar*) _tmp0_;
	_tmp1_ = str;
	g_unichar_to_utf8 (self, _tmp1_);
	result = str;
	return result;
}


gchar*
keymap_get_key_name (guint keyval)
{
	gchar* result = NULL;
	gunichar key_unicode = 0U;
	gunichar _tmp0_;
	key_unicode = (gunichar) gdk_keyval_to_unicode (gdk_keyval_to_lower (keyval));
	_tmp0_ = key_unicode;
	if (_tmp0_ == ((gunichar) 0)) {
		gchar* keyname = NULL;
		const gchar* _tmp1_;
		gchar* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp5_;
		_tmp1_ = gdk_keyval_name (keyval);
		_tmp2_ = g_strdup (_tmp1_);
		keyname = _tmp2_;
		_tmp3_ = keyname;
		if (_tmp3_ == NULL) {
			gchar* _tmp4_;
			_tmp4_ = g_strdup ("");
			result = _tmp4_;
			_g_free0 (keyname);
			return result;
		}
		_tmp5_ = keyname;
		if (g_strcmp0 (_tmp5_, "ISO_Left_Tab") == 0) {
			gchar* _tmp6_;
			_tmp6_ = g_strdup ("Tab");
			result = _tmp6_;
			_g_free0 (keyname);
			return result;
		} else {
			result = keyname;
			return result;
		}
		_g_free0 (keyname);
	} else {
		gunichar _tmp7_;
		_tmp7_ = key_unicode;
		if (_tmp7_ == ((gunichar) 13)) {
			gchar* _tmp8_;
			_tmp8_ = g_strdup ("Enter");
			result = _tmp8_;
			return result;
		} else {
			gunichar _tmp9_;
			_tmp9_ = key_unicode;
			if (_tmp9_ == ((gunichar) 9)) {
				gchar* _tmp10_;
				_tmp10_ = g_strdup ("Tab");
				result = _tmp10_;
				return result;
			} else {
				gunichar _tmp11_;
				_tmp11_ = key_unicode;
				if (_tmp11_ == ((gunichar) 27)) {
					gchar* _tmp12_;
					_tmp12_ = g_strdup ("Esc");
					result = _tmp12_;
					return result;
				} else {
					gunichar _tmp13_;
					_tmp13_ = key_unicode;
					if (_tmp13_ == ((gunichar) 8)) {
						gchar* _tmp14_;
						_tmp14_ = g_strdup ("Backspace");
						result = _tmp14_;
						return result;
					} else {
						gunichar _tmp15_;
						_tmp15_ = key_unicode;
						if (_tmp15_ == ((gunichar) 127)) {
							gchar* _tmp16_;
							_tmp16_ = g_strdup ("Delete");
							result = _tmp16_;
							return result;
						} else {
							gunichar _tmp17_;
							_tmp17_ = key_unicode;
							if (_tmp17_ == ((gunichar) 32)) {
								gchar* _tmp18_;
								_tmp18_ = g_strdup ("Space");
								result = _tmp18_;
								return result;
							} else {
								gunichar _tmp19_;
								gchar* _tmp20_;
								_tmp19_ = key_unicode;
								_tmp20_ = g_unichar_to_string (_tmp19_);
								result = _tmp20_;
								return result;
							}
						}
					}
				}
			}
		}
	}
}


static gboolean
_vala_string_array_contains (gchar* * stack,
                             int stack_length,
                             gchar* needle)
{
	int i;
	for (i = 0; i < stack_length; i++) {
		if (g_strcmp0 (stack[i], needle) == 0) {
			return TRUE;
		}
	}
	return FALSE;
}


gboolean
keymap_has_ctrl_mask (GdkEventKey* key_event)
{
	gboolean result = FALSE;
	gchar** mask_list = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar** _tmp2_;
	gint mask_list_length1;
	gint _mask_list_size_;
	guint _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gboolean _tmp6_;
	g_return_val_if_fail (key_event != NULL, FALSE);
	_tmp0_ = g_strdup ("Control_L");
	_tmp1_ = g_strdup ("Control_R");
	_tmp2_ = g_new0 (gchar*, 2 + 1);
	_tmp2_[0] = _tmp0_;
	_tmp2_[1] = _tmp1_;
	mask_list = _tmp2_;
	mask_list_length1 = 2;
	_mask_list_size_ = mask_list_length1;
	_tmp3_ = key_event->keyval;
	_tmp4_ = keymap_get_key_name (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = _vala_string_array_contains (mask_list, mask_list_length1, _tmp5_);
	_g_free0 (_tmp5_);
	result = _tmp6_;
	mask_list = (_vala_array_free (mask_list, mask_list_length1, (GDestroyNotify) g_free), NULL);
	return result;
}


gboolean
keymap_has_shift_mask (GdkEventKey* key_event)
{
	gboolean result = FALSE;
	gchar** mask_list = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar** _tmp2_;
	gint mask_list_length1;
	gint _mask_list_size_;
	guint _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gboolean _tmp6_;
	g_return_val_if_fail (key_event != NULL, FALSE);
	_tmp0_ = g_strdup ("Shift_L");
	_tmp1_ = g_strdup ("Shift_R");
	_tmp2_ = g_new0 (gchar*, 2 + 1);
	_tmp2_[0] = _tmp0_;
	_tmp2_[1] = _tmp1_;
	mask_list = _tmp2_;
	mask_list_length1 = 2;
	_mask_list_size_ = mask_list_length1;
	_tmp3_ = key_event->keyval;
	_tmp4_ = keymap_get_key_name (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = _vala_string_array_contains (mask_list, mask_list_length1, _tmp5_);
	_g_free0 (_tmp5_);
	result = _tmp6_;
	mask_list = (_vala_array_free (mask_list, mask_list_length1, (GDestroyNotify) g_free), NULL);
	return result;
}


gboolean
keymap_is_no_key_press (GdkEventKey* key_event)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	guint _tmp2_;
	g_return_val_if_fail (key_event != NULL, FALSE);
	_tmp2_ = key_event->is_modifier;
	if (_tmp2_ == ((guint) 0)) {
		guint _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		_tmp3_ = key_event->keyval;
		_tmp4_ = keymap_get_key_name (_tmp3_);
		_tmp5_ = _tmp4_;
		_tmp6_ = keymap_get_keyevent_name (key_event);
		_tmp7_ = _tmp6_;
		_tmp1_ = g_strcmp0 (_tmp5_, _tmp7_) == 0;
		_g_free0 (_tmp7_);
		_g_free0 (_tmp5_);
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp8_ = FALSE;
		guint _tmp9_;
		_tmp9_ = key_event->is_modifier;
		if (_tmp9_ != ((guint) 0)) {
			gint _tmp10_;
			gchar** _tmp11_;
			gchar** _tmp12_;
			gint _tmp12__length1;
			_tmp11_ = keymap_get_key_event_modifiers (key_event, &_tmp10_);
			_tmp12_ = _tmp11_;
			_tmp12__length1 = _tmp10_;
			_tmp8_ = _tmp10_ == 1;
			_tmp12_ = (_vala_array_free (_tmp12_, _tmp12__length1, (GDestroyNotify) g_free), NULL);
		} else {
			_tmp8_ = FALSE;
		}
		_tmp0_ = _tmp8_;
	}
	result = _tmp0_;
	return result;
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



