/* utils.c generated by valac 0.39.7, the Vala compiler
 * generated from utils.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 4 -*-
 * -*- coding: utf-8 -*-
 *
 * Copyright (C) 2011 ~ 2017 Deepin, Inc.
 *               2011 ~ 2017 Wang Yong
 *
 * Author:     Wang Yong <wangyong@deepin.com>
 * Maintainer: Wang Yong <wangyong@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <string.h>
#include <cairo.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <gee.h>
#include <stdlib.h>
#include <glib/gstdio.h>
#include <libsecret/secret.h>
#include <librsvg/rsvg.h>

#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _secret_schema_unref0(var) ((var == NULL) ? NULL : (var = (secret_schema_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))



gchar* project_path (void);
gchar* font_match (const gchar* family);
gchar** list_mono_or_dot_fonts (gint* num,
                                int* result_length1);
void utils_hex_to_rgba (const gchar* hex_color,
                        gdouble alpha,
                        GdkRGBA* result);
void utils_set_context_color (cairo_t* cr,
                              GdkRGBA* color);
void utils_propagate_draw (GtkContainer* widget,
                           cairo_t* cr);
gboolean utils_is_light_color (const gchar* color_string);
gdouble utils_get_color_brightness (const gchar* color_string);
void utils_touch_dir (const gchar* dir);
void utils_create_file (const gchar* file_path);
GeeArrayList* utils_list_files (const gchar* path);
void utils_remove_all_children (GtkContainer* container);
void utils_destroy_all_children (GtkContainer* container);
void utils_get_origin_allocation (GtkWidget* w,
                                  GtkAllocation* result);
gboolean utils_move_window (GtkWidget* widget,
                            GdkEventButton* event,
                            GtkWindow* window);
gboolean utils_is_left_button (GdkEventButton* event);
void utils_toggle_max_window (GtkWindow* window);
gboolean utils_is_right_button (GdkEventButton* event);
gboolean utils_is_double_click (GdkEventButton* event);
void utils_load_css_theme (const gchar* css_path);
gchar* utils_slice_string (const gchar* str,
                           gint unichar_num);
gboolean utils_is_command_exist (const gchar* command_name);
gchar* utils_get_command_output (const gchar* cmd);
gchar* utils_get_proc_file_content (const gchar* proc_file_path);
gchar* utils_get_image_path (const gchar* image_name);
gchar* utils_get_theme_path (const gchar* theme_name);
gchar* utils_get_theme_dir (void);
gchar* utils_get_root_path (const gchar* file_path);
gchar* utils_get_config_dir (void);
gchar* utils_get_config_file_path (const gchar* config_name);
gchar* utils_get_ssh_script_path (void);
gchar* utils_get_default_private_key_path (void);
gchar* utils_lookup_password (const gchar* user,
                              const gchar* server_address,
                              const gchar* port);
void utils_store_password (const gchar* user,
                           const gchar* server_address,
                           gint port,
                           const gchar* password);
static void _g_free0_ (gpointer var);
static void __lambda6_ (GObject* obj,
                 GAsyncResult* async_res);
static void ___lambda6__gasync_ready_callback (GObject* source_object,
                                        GAsyncResult* res,
                                        gpointer self);
void utils_get_pointer_position (gint* x,
                                 gint* y);
gboolean utils_pointer_in_widget_area (GtkWidget* widget);
void utils_show_manual (void);
void utils_write_log (const gchar* log);
cairo_surface_t* utils_create_image_surface (const gchar* surface_path);
gdouble utils_get_default_monitor_scale (void);
gint utils_get_active_monitor (GdkScreen* screen);
gdouble utils_get_dde_scale_ratio (void);
gint utils_get_pointer_monitor (GdkScreen* screen);
gchar* utils_get_process_cmdline (gint pid);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


void
utils_hex_to_rgba (const gchar* hex_color,
                   gdouble alpha,
                   GdkRGBA* result)
{
	GdkRGBA rgba_color = {0};
	g_return_if_fail (hex_color != NULL);
	memset (&rgba_color, 0, sizeof (GdkRGBA));
	gdk_rgba_parse (&rgba_color, hex_color);
	rgba_color.alpha = alpha;
	*result = rgba_color;
	return;
}


void
utils_set_context_color (cairo_t* cr,
                         GdkRGBA* color)
{
	GdkRGBA _tmp0_;
	gdouble _tmp1_;
	GdkRGBA _tmp2_;
	gdouble _tmp3_;
	GdkRGBA _tmp4_;
	gdouble _tmp5_;
	GdkRGBA _tmp6_;
	gdouble _tmp7_;
	g_return_if_fail (cr != NULL);
	g_return_if_fail (color != NULL);
	_tmp0_ = *color;
	_tmp1_ = _tmp0_.red;
	_tmp2_ = *color;
	_tmp3_ = _tmp2_.green;
	_tmp4_ = *color;
	_tmp5_ = _tmp4_.blue;
	_tmp6_ = *color;
	_tmp7_ = _tmp6_.alpha;
	cairo_set_source_rgba (cr, _tmp1_, _tmp3_, _tmp5_, _tmp7_);
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


void
utils_propagate_draw (GtkContainer* widget,
                      cairo_t* cr)
{
	GList* _tmp0_;
	GList* _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (widget != NULL);
	g_return_if_fail (cr != NULL);
	_tmp0_ = gtk_container_get_children (widget);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_list_length (_tmp1_) > ((guint) 0);
	_g_list_free0 (_tmp1_);
	if (_tmp2_) {
		GList* _tmp3_;
		_tmp3_ = gtk_container_get_children (widget);
		{
			GList* child_collection = NULL;
			GList* child_it = NULL;
			child_collection = _tmp3_;
			for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
				GtkWidget* _tmp4_;
				GtkWidget* child = NULL;
				_tmp4_ = _g_object_ref0 ((GtkWidget*) child_it->data);
				child = _tmp4_;
				{
					GtkWidget* _tmp5_;
					_tmp5_ = child;
					gtk_container_propagate_draw (widget, _tmp5_, cr);
					_g_object_unref0 (child);
				}
			}
			_g_list_free0 (child_collection);
		}
	}
}


gboolean
utils_is_light_color (const gchar* color_string)
{
	gboolean result = FALSE;
	GdkRGBA color = {0};
	gdouble r = 0.0;
	GdkRGBA _tmp0_;
	gdouble _tmp1_;
	gdouble g = 0.0;
	GdkRGBA _tmp2_;
	gdouble _tmp3_;
	gdouble b = 0.0;
	GdkRGBA _tmp4_;
	gdouble _tmp5_;
	gdouble max_v = 0.0;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble min_v = 0.0;
	gdouble _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	gdouble s = 0.0;
	gdouble _tmp12_;
	gdouble _tmp15_;
	gboolean _tmp16_ = FALSE;
	gdouble _tmp17_;
	g_return_val_if_fail (color_string != NULL, FALSE);
	memset (&color, 0, sizeof (GdkRGBA));
	gdk_rgba_parse (&color, color_string);
	_tmp0_ = color;
	_tmp1_ = _tmp0_.red;
	r = _tmp1_;
	_tmp2_ = color;
	_tmp3_ = _tmp2_.green;
	g = _tmp3_;
	_tmp4_ = color;
	_tmp5_ = _tmp4_.blue;
	b = _tmp5_;
	_tmp6_ = r;
	_tmp7_ = g;
	_tmp8_ = b;
	max_v = MAX (_tmp6_, MAX (_tmp7_, _tmp8_));
	_tmp9_ = r;
	_tmp10_ = g;
	_tmp11_ = b;
	min_v = MIN (_tmp9_, MIN (_tmp10_, _tmp11_));
	_tmp12_ = max_v;
	if (_tmp12_ == ((gdouble) 0)) {
		s = 0.0;
	} else {
		gdouble _tmp13_;
		gdouble _tmp14_;
		_tmp13_ = min_v;
		_tmp14_ = max_v;
		s = 1.0 - (_tmp13_ / _tmp14_);
	}
	_tmp15_ = max_v;
	b = _tmp15_;
	_tmp17_ = b;
	if (_tmp17_ > 0.35) {
		gdouble _tmp18_;
		_tmp18_ = s;
		_tmp16_ = _tmp18_ < 0.7;
	} else {
		_tmp16_ = FALSE;
	}
	result = _tmp16_;
	return result;
}


gdouble
utils_get_color_brightness (const gchar* color_string)
{
	gdouble result = 0.0;
	GdkRGBA color = {0};
	gdouble r = 0.0;
	GdkRGBA _tmp0_;
	gdouble _tmp1_;
	gdouble g = 0.0;
	GdkRGBA _tmp2_;
	gdouble _tmp3_;
	gdouble b = 0.0;
	GdkRGBA _tmp4_;
	gdouble _tmp5_;
	gdouble max_v = 0.0;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble min_v = 0.0;
	gdouble _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	gdouble s = 0.0;
	gdouble _tmp12_;
	gdouble _tmp15_;
	g_return_val_if_fail (color_string != NULL, 0.0);
	memset (&color, 0, sizeof (GdkRGBA));
	gdk_rgba_parse (&color, color_string);
	_tmp0_ = color;
	_tmp1_ = _tmp0_.red;
	r = _tmp1_;
	_tmp2_ = color;
	_tmp3_ = _tmp2_.green;
	g = _tmp3_;
	_tmp4_ = color;
	_tmp5_ = _tmp4_.blue;
	b = _tmp5_;
	_tmp6_ = r;
	_tmp7_ = g;
	_tmp8_ = b;
	max_v = MAX (_tmp6_, MAX (_tmp7_, _tmp8_));
	_tmp9_ = r;
	_tmp10_ = g;
	_tmp11_ = b;
	min_v = MIN (_tmp9_, MIN (_tmp10_, _tmp11_));
	_tmp12_ = max_v;
	if (_tmp12_ == ((gdouble) 0)) {
		s = 0.0;
	} else {
		gdouble _tmp13_;
		gdouble _tmp14_;
		_tmp13_ = min_v;
		_tmp14_ = max_v;
		s = 1.0 - (_tmp13_ / _tmp14_);
	}
	_tmp15_ = max_v;
	b = _tmp15_;
	result = b;
	return result;
}


void
utils_touch_dir (const gchar* dir)
{
	GFile* dir_file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (dir != NULL);
	_tmp0_ = g_file_new_for_path (dir);
	dir_file = _tmp0_;
	_tmp1_ = dir_file;
	if (!g_file_query_exists (_tmp1_, NULL)) {
		{
			GFile* _tmp2_;
			_tmp2_ = dir_file;
			g_file_make_directory_with_parents (_tmp2_, NULL, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch14_g_error;
			}
		}
		goto __finally14;
		__catch14_g_error:
		{
			GError* err = NULL;
			GError* _tmp3_;
			const gchar* _tmp4_;
			err = _inner_error_;
			_inner_error_ = NULL;
			_tmp3_ = err;
			_tmp4_ = _tmp3_->message;
			g_print ("Could not create dir: %s\n", _tmp4_);
			_g_error_free0 (err);
		}
		__finally14:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (dir_file);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_g_object_unref0 (dir_file);
}


void
utils_create_file (const gchar* file_path)
{
	GFile* file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (file_path != NULL);
	_tmp0_ = g_file_new_for_path (file_path);
	file = _tmp0_;
	_tmp1_ = file;
	if (!g_file_query_exists (_tmp1_, NULL)) {
		{
			GFile* _tmp2_;
			GFileOutputStream* _tmp3_;
			GFileOutputStream* _tmp4_;
			_tmp2_ = file;
			_tmp3_ = g_file_create (_tmp2_, G_FILE_CREATE_NONE, NULL, &_inner_error_);
			_tmp4_ = _tmp3_;
			_g_object_unref0 (_tmp4_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch15_g_error;
			}
		}
		goto __finally15;
		__catch15_g_error:
		{
			GError* e = NULL;
			GError* _tmp5_;
			const gchar* _tmp6_;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp5_ = e;
			_tmp6_ = _tmp5_->message;
			g_print ("create_file: %s\n", _tmp6_);
			_g_error_free0 (e);
		}
		__finally15:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (file);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_g_object_unref0 (file);
}


GeeArrayList*
utils_list_files (const gchar* path)
{
	GeeArrayList* result = NULL;
	GeeArrayList* files = NULL;
	GeeArrayList* _tmp0_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (path != NULL, NULL);
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
	files = _tmp0_;
	{
		GFileEnumerator* enumerator = NULL;
		GFile* _tmp1_;
		GFile* _tmp2_;
		GFileEnumerator* _tmp3_;
		GFileEnumerator* _tmp4_;
		GFileInfo* info = NULL;
		_tmp1_ = g_file_new_for_path (path);
		_tmp2_ = _tmp1_;
		_tmp3_ = g_file_enumerate_children (_tmp2_, "standard::*", G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
		_tmp4_ = _tmp3_;
		_g_object_unref0 (_tmp2_);
		enumerator = _tmp4_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch16_g_error;
		}
		info = NULL;
		while (TRUE) {
			GFileInfo* _tmp5_ = NULL;
			GFileEnumerator* _tmp6_;
			GFileInfo* _tmp7_;
			GFileInfo* _tmp8_;
			GFileInfo* _tmp9_;
			GFileInfo* _tmp10_;
			_tmp6_ = enumerator;
			_tmp7_ = g_file_enumerator_next_file (_tmp6_, NULL, &_inner_error_);
			_tmp5_ = _tmp7_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				_g_object_unref0 (info);
				_g_object_unref0 (enumerator);
				goto __catch16_g_error;
			}
			_tmp8_ = _tmp5_;
			_tmp5_ = NULL;
			_g_object_unref0 (info);
			info = _tmp8_;
			_tmp9_ = info;
			if (!(_tmp9_ != NULL)) {
				_g_object_unref0 (_tmp5_);
				break;
			}
			_tmp10_ = info;
			if (g_file_info_get_file_type (_tmp10_) != G_FILE_TYPE_DIRECTORY) {
				GeeArrayList* _tmp11_;
				GFileInfo* _tmp12_;
				const gchar* _tmp13_;
				_tmp11_ = files;
				_tmp12_ = info;
				_tmp13_ = g_file_info_get_name (_tmp12_);
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp11_, _tmp13_);
			}
			_g_object_unref0 (_tmp5_);
		}
		_g_object_unref0 (info);
		_g_object_unref0 (enumerator);
	}
	goto __finally16;
	__catch16_g_error:
	{
		GError* e = NULL;
		GError* _tmp14_;
		const gchar* _tmp15_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp14_ = e;
		_tmp15_ = _tmp14_->message;
		g_print ("list_files: %s\n", _tmp15_);
		_g_error_free0 (e);
	}
	__finally16:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (files);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	result = files;
	return result;
}


void
utils_remove_all_children (GtkContainer* container)
{
	GList* _tmp0_;
	g_return_if_fail (container != NULL);
	_tmp0_ = gtk_container_get_children (container);
	{
		GList* w_collection = NULL;
		GList* w_it = NULL;
		w_collection = _tmp0_;
		for (w_it = w_collection; w_it != NULL; w_it = w_it->next) {
			GtkWidget* _tmp1_;
			GtkWidget* w = NULL;
			_tmp1_ = _g_object_ref0 ((GtkWidget*) w_it->data);
			w = _tmp1_;
			{
				GtkWidget* _tmp2_;
				_tmp2_ = w;
				gtk_container_remove (container, _tmp2_);
				_g_object_unref0 (w);
			}
		}
		_g_list_free0 (w_collection);
	}
}


void
utils_destroy_all_children (GtkContainer* container)
{
	GList* _tmp0_;
	g_return_if_fail (container != NULL);
	_tmp0_ = gtk_container_get_children (container);
	{
		GList* w_collection = NULL;
		GList* w_it = NULL;
		w_collection = _tmp0_;
		for (w_it = w_collection; w_it != NULL; w_it = w_it->next) {
			GtkWidget* _tmp1_;
			GtkWidget* w = NULL;
			_tmp1_ = _g_object_ref0 ((GtkWidget*) w_it->data);
			w = _tmp1_;
			{
				GtkWidget* _tmp2_;
				GtkWidget* _tmp3_;
				_tmp2_ = w;
				gtk_container_remove (container, _tmp2_);
				_tmp3_ = w;
				gtk_widget_destroy (_tmp3_);
				_g_object_unref0 (w);
			}
		}
		_g_list_free0 (w_collection);
	}
}


void
utils_get_origin_allocation (GtkWidget* w,
                             GtkAllocation* result)
{
	GtkAllocation alloc = {0};
	GtkAllocation _tmp0_ = {0};
	GtkWidget* _tmp1_;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	g_return_if_fail (w != NULL);
	gtk_widget_get_allocation (w, &_tmp0_);
	alloc = _tmp0_;
	_tmp1_ = gtk_widget_get_toplevel (w);
	gtk_widget_translate_coordinates (w, _tmp1_, 0, 0, &_tmp2_, &_tmp3_);
	alloc.x = _tmp2_;
	alloc.y = _tmp3_;
	*result = alloc;
	return;
}


gboolean
utils_move_window (GtkWidget* widget,
                   GdkEventButton* event,
                   GtkWindow* window)
{
	gboolean result = FALSE;
	g_return_val_if_fail (widget != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	g_return_val_if_fail (window != NULL, FALSE);
	if (utils_is_left_button (event)) {
		guint _tmp0_;
		gdouble _tmp1_;
		gdouble _tmp2_;
		guint32 _tmp3_;
		_tmp0_ = event->button;
		_tmp1_ = event->x_root;
		_tmp2_ = event->y_root;
		_tmp3_ = event->time;
		gtk_window_begin_move_drag (window, (gint) _tmp0_, (gint) _tmp1_, (gint) _tmp2_, _tmp3_);
	}
	result = FALSE;
	return result;
}


void
utils_toggle_max_window (GtkWindow* window)
{
	GdkWindowState window_state = 0;
	GdkWindow* _tmp0_;
	GdkWindowState _tmp1_;
	g_return_if_fail (window != NULL);
	_tmp0_ = gtk_widget_get_window ((GtkWidget*) window);
	window_state = gdk_window_get_state (_tmp0_);
	_tmp1_ = window_state;
	if ((_tmp1_ & GDK_WINDOW_STATE_MAXIMIZED) == GDK_WINDOW_STATE_MAXIMIZED) {
		gtk_window_unmaximize (window);
	} else {
		gtk_window_maximize (window);
	}
}


gboolean
utils_is_left_button (GdkEventButton* event)
{
	gboolean result = FALSE;
	guint _tmp0_;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = event->button;
	result = _tmp0_ == ((guint) 1);
	return result;
}


gboolean
utils_is_right_button (GdkEventButton* event)
{
	gboolean result = FALSE;
	guint _tmp0_;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = event->button;
	result = _tmp0_ == ((guint) 3);
	return result;
}


gboolean
utils_is_double_click (GdkEventButton* event)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	guint _tmp1_;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp1_ = event->button;
	if (_tmp1_ == ((guint) 1)) {
		GdkEventType _tmp2_;
		_tmp2_ = event->type;
		_tmp0_ = _tmp2_ == GDK_2BUTTON_PRESS;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


void
utils_load_css_theme (const gchar* css_path)
{
	GdkScreen* screen = NULL;
	GdkScreen* _tmp0_;
	GdkScreen* _tmp1_;
	GtkCssProvider* css_provider = NULL;
	GtkCssProvider* _tmp2_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (css_path != NULL);
	_tmp0_ = gdk_screen_get_default ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	screen = _tmp1_;
	_tmp2_ = gtk_css_provider_new ();
	css_provider = _tmp2_;
	{
		gtk_css_provider_load_from_path (css_provider, css_path, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch17_g_error;
		}
	}
	goto __finally17;
	__catch17_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp3_ = e;
		_tmp4_ = _tmp3_->message;
		g_print ("Got error when load css: %s\n", _tmp4_);
		_g_error_free0 (e);
	}
	__finally17:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (css_provider);
		_g_object_unref0 (screen);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	gtk_style_context_add_provider_for_screen (screen, (GtkStyleProvider*) css_provider, (guint) GTK_STYLE_PROVIDER_PRIORITY_USER);
	_g_object_unref0 (css_provider);
	_g_object_unref0 (screen);
}


static gboolean
string_get_next_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result = FALSE;
	gunichar _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
	_tmp0_ = _vala_c;
	if (_tmp0_ != ((gunichar) 0)) {
		gchar* _tmp1_;
		_tmp1_ = g_utf8_next_char (((gchar*) self) + (*index));
		*index = (gint) (_tmp1_ - ((gchar*) self));
		result = TRUE;
		if (c) {
			*c = _vala_c;
		}
		return result;
	} else {
		result = FALSE;
		if (c) {
			*c = _vala_c;
		}
		return result;
	}
	if (c) {
		*c = _vala_c;
	}
}


static gchar*
g_unichar_to_string (gunichar self)
{
	gchar* result = NULL;
	gchar* str = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	_tmp0_ = g_new0 (gchar, 7);
	str = (gchar*) _tmp0_;
	_tmp1_ = str;
	g_unichar_to_utf8 (self, _tmp1_);
	result = str;
	return result;
}


gchar*
utils_slice_string (const gchar* str,
                    gint unichar_num)
{
	gchar* result = NULL;
	gchar* slice_str = NULL;
	gchar* _tmp0_;
	gunichar c = 0U;
	g_return_val_if_fail (str != NULL, NULL);
	_tmp0_ = g_strdup ("");
	slice_str = _tmp0_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				gunichar _tmp2_ = 0U;
				gboolean _tmp3_;
				gint _tmp4_;
				if (!_tmp1_) {
				}
				_tmp1_ = FALSE;
				_tmp3_ = string_get_next_char (str, &i, &_tmp2_);
				c = _tmp2_;
				if (!_tmp3_) {
					break;
				}
				_tmp4_ = i;
				if (_tmp4_ > unichar_num) {
					const gchar* _tmp5_;
					gchar* _tmp6_;
					_tmp5_ = slice_str;
					_tmp6_ = g_strconcat (_tmp5_, "... ", NULL);
					result = _tmp6_;
					_g_free0 (slice_str);
					return result;
				} else {
					const gchar* _tmp7_;
					gunichar _tmp8_;
					gchar* _tmp9_;
					gchar* _tmp10_;
					gchar* _tmp11_;
					_tmp7_ = slice_str;
					_tmp8_ = c;
					_tmp9_ = g_unichar_to_string (_tmp8_);
					_tmp10_ = _tmp9_;
					_tmp11_ = g_strconcat (_tmp7_, _tmp10_, NULL);
					_g_free0 (slice_str);
					slice_str = _tmp11_;
					_g_free0 (_tmp10_);
				}
			}
		}
	}
	result = slice_str;
	return result;
}


gboolean
utils_is_command_exist (const gchar* command_name)
{
	gboolean result = FALSE;
	gchar* paths = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	g_return_val_if_fail (command_name != NULL, FALSE);
	_tmp0_ = g_getenv ("PATH");
	_tmp1_ = g_strdup (_tmp0_);
	paths = _tmp1_;
	_tmp2_ = paths;
	_tmp4_ = _tmp3_ = g_strsplit (_tmp2_, ":", 0);
	{
		gchar** bin_path_collection = NULL;
		gint bin_path_collection_length1 = 0;
		gint _bin_path_collection_size_ = 0;
		gint bin_path_it = 0;
		bin_path_collection = _tmp4_;
		bin_path_collection_length1 = _vala_array_length (_tmp3_);
		for (bin_path_it = 0; bin_path_it < _vala_array_length (_tmp3_); bin_path_it = bin_path_it + 1) {
			gchar* _tmp5_;
			gchar* bin_path = NULL;
			_tmp5_ = g_strdup (bin_path_collection[bin_path_it]);
			bin_path = _tmp5_;
			{
				GFile* file = NULL;
				const gchar* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
				GFile* _tmp9_;
				GFile* _tmp10_;
				GFile* _tmp11_;
				_tmp6_ = bin_path;
				_tmp7_ = g_build_path (G_DIR_SEPARATOR_S, _tmp6_, command_name, NULL);
				_tmp8_ = _tmp7_;
				_tmp9_ = g_file_new_for_path (_tmp8_);
				_tmp10_ = _tmp9_;
				_g_free0 (_tmp8_);
				file = _tmp10_;
				_tmp11_ = file;
				if (g_file_query_exists (_tmp11_, NULL)) {
					result = TRUE;
					_g_object_unref0 (file);
					_g_free0 (bin_path);
					bin_path_collection = (_vala_array_free (bin_path_collection, bin_path_collection_length1, (GDestroyNotify) g_free), NULL);
					_g_free0 (paths);
					return result;
				}
				_g_object_unref0 (file);
				_g_free0 (bin_path);
			}
		}
		bin_path_collection = (_vala_array_free (bin_path_collection, bin_path_collection_length1, (GDestroyNotify) g_free), NULL);
	}
	result = FALSE;
	_g_free0 (paths);
	return result;
}


gchar*
utils_get_command_output (const gchar* cmd)
{
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (cmd != NULL, NULL);
	{
		gint exit_code = 0;
		gchar* std_out = NULL;
		gchar* _tmp0_ = NULL;
		gint _tmp1_ = 0;
		g_spawn_command_line_sync (cmd, &_tmp0_, NULL, &_tmp1_, &_inner_error_);
		_g_free0 (std_out);
		std_out = _tmp0_;
		exit_code = _tmp1_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_free0 (std_out);
			goto __catch18_g_error;
		}
		result = std_out;
		return result;
	}
	goto __finally18;
	__catch18_g_error:
	{
		GError* e = NULL;
		gchar* _tmp2_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp2_ = g_strdup ("");
		result = _tmp2_;
		_g_error_free0 (e);
		return result;
	}
	__finally18:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
	g_clear_error (&_inner_error_);
	return NULL;
}


gchar*
utils_get_proc_file_content (const gchar* proc_file_path)
{
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (proc_file_path != NULL, NULL);
	{
		guint8* data = NULL;
		gint data_length1 = 0;
		gint _data_size_ = 0;
		guint8* _tmp0_ = NULL;
		size_t _tmp1_;
		guint8* _tmp2_;
		gint _tmp2__length1;
		g_file_get_contents (proc_file_path, (gchar**) (&_tmp0_), &_tmp1_, &_inner_error_);
		data = (g_free (data), NULL);
		data = _tmp0_;
		data_length1 = _tmp1_;
		_data_size_ = data_length1;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			data = (g_free (data), NULL);
			goto __catch19_g_error;
		}
		_tmp2_ = data;
		_tmp2__length1 = data_length1;
		if (_tmp2_ != NULL) {
			guint8* _tmp13_;
			gint _tmp13__length1;
			gchar* _tmp14_;
			{
				gint i = 0;
				i = 0;
				{
					gboolean _tmp3_ = FALSE;
					_tmp3_ = TRUE;
					while (TRUE) {
						gint _tmp5_;
						guint8* _tmp6_;
						gint _tmp6__length1;
						guint8* _tmp7_;
						gint _tmp7__length1;
						gint _tmp8_;
						guint8 _tmp9_;
						if (!_tmp3_) {
							gint _tmp4_;
							_tmp4_ = i;
							i = _tmp4_ + 1;
						}
						_tmp3_ = FALSE;
						_tmp5_ = i;
						_tmp6_ = data;
						_tmp6__length1 = data_length1;
						if (!(_tmp5_ < (_tmp6__length1 - 1))) {
							break;
						}
						_tmp7_ = data;
						_tmp7__length1 = data_length1;
						_tmp8_ = i;
						_tmp9_ = _tmp7_[_tmp8_];
						if (((gint) _tmp9_) == 0) {
							guint8* _tmp10_;
							gint _tmp10__length1;
							gint _tmp11_;
							guint8 _tmp12_;
							_tmp10_ = data;
							_tmp10__length1 = data_length1;
							_tmp11_ = i;
							_tmp10_[_tmp11_] = (guint8) ' ';
							_tmp12_ = _tmp10_[_tmp11_];
						}
					}
				}
			}
			_tmp13_ = data;
			_tmp13__length1 = data_length1;
			_tmp14_ = g_strdup ((const gchar*) _tmp13_);
			result = _tmp14_;
			data = (g_free (data), NULL);
			return result;
		} else {
			gchar* _tmp15_;
			_tmp15_ = g_strdup ("");
			result = _tmp15_;
			data = (g_free (data), NULL);
			return result;
		}
		data = (g_free (data), NULL);
	}
	goto __finally19;
	__catch19_g_error:
	{
		GError* e = NULL;
		GError* _tmp16_;
		const gchar* _tmp17_;
		gchar* _tmp18_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp16_ = e;
		_tmp17_ = _tmp16_->message;
		g_print ("get_proc_file_content: %s\n", _tmp17_);
		_tmp18_ = g_strdup ("");
		result = _tmp18_;
		_g_error_free0 (e);
		return result;
	}
	__finally19:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
	g_clear_error (&_inner_error_);
	return NULL;
}


gchar*
utils_get_image_path (const gchar* image_name)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	g_return_val_if_fail (image_name != NULL, NULL);
	_tmp0_ = project_path ();
	_tmp1_ = g_path_get_dirname ((const gchar*) _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_build_path (G_DIR_SEPARATOR_S, _tmp2_, "image", image_name, NULL);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	result = _tmp4_;
	return result;
}


gchar*
utils_get_theme_path (const gchar* theme_name)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	g_return_val_if_fail (theme_name != NULL, NULL);
	_tmp0_ = project_path ();
	_tmp1_ = g_path_get_dirname ((const gchar*) _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_build_path (G_DIR_SEPARATOR_S, _tmp2_, "theme", theme_name, NULL);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	result = _tmp4_;
	return result;
}


gchar*
utils_get_theme_dir (void)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	_tmp0_ = project_path ();
	_tmp1_ = g_path_get_dirname ((const gchar*) _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_build_path (G_DIR_SEPARATOR_S, _tmp2_, "theme", NULL);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	result = _tmp4_;
	return result;
}


gchar*
utils_get_root_path (const gchar* file_path)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	g_return_val_if_fail (file_path != NULL, NULL);
	_tmp0_ = project_path ();
	_tmp1_ = g_path_get_dirname ((const gchar*) _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_build_path (G_DIR_SEPARATOR_S, _tmp2_, file_path, NULL);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	result = _tmp4_;
	return result;
}


gchar*
utils_get_config_dir (void)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	_tmp0_ = g_get_user_config_dir ();
	_tmp1_ = g_build_path (G_DIR_SEPARATOR_S, _tmp0_, "deepin", "deepin-terminal", NULL);
	result = _tmp1_;
	return result;
}


gchar*
utils_get_config_file_path (const gchar* config_name)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (config_name != NULL, NULL);
	_tmp0_ = g_get_user_config_dir ();
	_tmp1_ = g_build_path (G_DIR_SEPARATOR_S, _tmp0_, "deepin", "deepin-terminal", config_name, NULL);
	result = _tmp1_;
	return result;
}


gchar*
utils_get_ssh_script_path (void)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	_tmp0_ = g_strdup ("/usr/libexec/deepin-terminal/ssh_login.sh");
	result = _tmp0_;
	return result;
}


gchar*
utils_get_default_private_key_path (void)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	_tmp0_ = g_get_home_dir ();
	_tmp1_ = g_build_path (G_DIR_SEPARATOR_S, _tmp0_, ".ssh", "id_rsa", NULL);
	result = _tmp1_;
	return result;
}


gchar*
utils_lookup_password (const gchar* user,
                       const gchar* server_address,
                       const gchar* port)
{
	gchar* result = NULL;
	SecretSchema* password_schema = NULL;
	gchar* password = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (user != NULL, NULL);
	g_return_val_if_fail (server_address != NULL, NULL);
	if (port == NULL) {
		gchar* _tmp0_;
		gchar* _tmp1_;
		SecretSchema* _tmp2_;
		_tmp0_ = g_strdup_printf ("com.deepin.terminal.password.%s.%s", user, server_address);
		_tmp1_ = _tmp0_;
		_tmp2_ = secret_schema_new (_tmp1_, SECRET_SCHEMA_NONE, "number", SECRET_SCHEMA_ATTRIBUTE_INTEGER, "string", SECRET_SCHEMA_ATTRIBUTE_STRING, "even", SECRET_SCHEMA_ATTRIBUTE_BOOLEAN, NULL);
		_secret_schema_unref0 (password_schema);
		password_schema = _tmp2_;
		_g_free0 (_tmp1_);
	} else {
		gchar* _tmp3_;
		gchar* _tmp4_;
		SecretSchema* _tmp5_;
		_tmp3_ = g_strdup_printf ("com.deepin.terminal.password.%s.%s.%s", user, server_address, port);
		_tmp4_ = _tmp3_;
		_tmp5_ = secret_schema_new (_tmp4_, SECRET_SCHEMA_NONE, "number", SECRET_SCHEMA_ATTRIBUTE_INTEGER, "string", SECRET_SCHEMA_ATTRIBUTE_STRING, "even", SECRET_SCHEMA_ATTRIBUTE_BOOLEAN, NULL);
		_secret_schema_unref0 (password_schema);
		password_schema = _tmp5_;
		_g_free0 (_tmp4_);
	}
	{
		gchar* _tmp6_ = NULL;
		SecretSchema* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		_tmp7_ = password_schema;
		_tmp8_ = secret_password_lookup_sync (_tmp7_, NULL, &_inner_error_, NULL, "number", 8, "string", "eight", "even", TRUE, NULL);
		_tmp6_ = _tmp8_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch20_g_error;
		}
		_tmp9_ = _tmp6_;
		_tmp6_ = NULL;
		_g_free0 (password);
		password = _tmp9_;
		_g_free0 (_tmp6_);
	}
	goto __finally20;
	__catch20_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp10_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp10_ = e->message;
		g_error ("utils.vala:325: %s", _tmp10_);
		_g_error_free0 (e);
	}
	__finally20:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_free0 (password);
		_secret_schema_unref0 (password_schema);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	if (password == NULL) {
		gchar* _tmp11_;
		_tmp11_ = g_strdup ("");
		result = _tmp11_;
		_g_free0 (password);
		_secret_schema_unref0 (password_schema);
		return result;
	} else {
		result = password;
		_secret_schema_unref0 (password_schema);
		return result;
	}
	_g_free0 (password);
	_secret_schema_unref0 (password_schema);
}


static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}


static void
__lambda6_ (GObject* obj,
            GAsyncResult* async_res)
{
	GError * _inner_error_ = NULL;
	g_return_if_fail (async_res != NULL);
	{
		secret_password_store_finish (async_res, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch22_g_error;
		}
	}
	goto __finally22;
	__catch22_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp0_ = e;
		_tmp1_ = _tmp0_->message;
		g_print ("%s", _tmp1_);
		_g_error_free0 (e);
		return;
	}
	__finally22:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void
___lambda6__gasync_ready_callback (GObject* source_object,
                                   GAsyncResult* res,
                                   gpointer self)
{
	__lambda6_ (source_object, res);
}


void
utils_store_password (const gchar* user,
                      const gchar* server_address,
                      gint port,
                      const gchar* password)
{
	SecretSchema* password_schema = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	SecretSchema* _tmp2_;
	SecretSchema* _tmp3_;
	GHashTable* attributes = NULL;
	GHashTable* _tmp4_;
	GHashTable* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GHashTable* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GHashTable* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	SecretSchema* _tmp17_;
	GHashTable* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (user != NULL);
	g_return_if_fail (server_address != NULL);
	g_return_if_fail (password != NULL);
	_tmp0_ = g_strdup_printf ("com.deepin.terminal.password.%s.%s.%i", user, server_address, port);
	_tmp1_ = _tmp0_;
	_tmp2_ = secret_schema_new (_tmp1_, SECRET_SCHEMA_NONE, "number", SECRET_SCHEMA_ATTRIBUTE_INTEGER, "string", SECRET_SCHEMA_ATTRIBUTE_STRING, "even", SECRET_SCHEMA_ATTRIBUTE_BOOLEAN, NULL);
	_tmp3_ = _tmp2_;
	_g_free0 (_tmp1_);
	password_schema = _tmp3_;
	_tmp4_ = g_hash_table_new_full (NULL, NULL, _g_free0_, _g_free0_);
	attributes = _tmp4_;
	_tmp5_ = attributes;
	_tmp6_ = g_strdup ("number");
	_tmp7_ = g_strdup ("8");
	g_hash_table_insert (_tmp5_, _tmp6_, _tmp7_);
	_tmp8_ = attributes;
	_tmp9_ = g_strdup ("string");
	_tmp10_ = g_strdup ("eight");
	g_hash_table_insert (_tmp8_, _tmp9_, _tmp10_);
	_tmp11_ = attributes;
	_tmp12_ = g_strdup ("even");
	_tmp13_ = g_strdup ("true");
	g_hash_table_insert (_tmp11_, _tmp12_, _tmp13_);
	{
		SecretSchema* _tmp14_;
		_tmp14_ = password_schema;
		secret_password_clear_sync (_tmp14_, NULL, &_inner_error_, "number", 8, "string", "eight", "even", TRUE, NULL);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch21_g_error;
		}
	}
	goto __finally21;
	__catch21_g_error:
	{
		GError* e = NULL;
		GError* _tmp15_;
		const gchar* _tmp16_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp15_ = e;
		_tmp16_ = _tmp15_->message;
		g_print ("%s", _tmp16_);
		_g_error_free0 (e);
		_g_hash_table_unref0 (attributes);
		_secret_schema_unref0 (password_schema);
		return;
	}
	__finally21:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_hash_table_unref0 (attributes);
		_secret_schema_unref0 (password_schema);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_tmp17_ = password_schema;
	_tmp18_ = attributes;
	_tmp19_ = g_strdup_printf ("com.deepin.terminal.password.%s.%s", user, server_address);
	_tmp20_ = _tmp19_;
	secret_password_storev (_tmp17_, _tmp18_, SECRET_COLLECTION_DEFAULT, _tmp20_, password, NULL, ___lambda6__gasync_ready_callback, NULL);
	_g_free0 (_tmp20_);
	_g_hash_table_unref0 (attributes);
	_secret_schema_unref0 (password_schema);
}


void
utils_get_pointer_position (gint* x,
                            gint* y)
{
	gint _vala_x = 0;
	gint _vala_y = 0;
	GdkDisplay* gdk_display = NULL;
	GdkDisplay* _tmp0_;
	GdkDisplay* _tmp1_;
	GdkSeat* seat = NULL;
	GdkSeat* _tmp2_;
	GdkSeat* _tmp3_;
	GdkDevice* device = NULL;
	GdkDevice* _tmp4_;
	GdkDevice* _tmp5_;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	_tmp0_ = gdk_display_get_default ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	gdk_display = _tmp1_;
	_tmp2_ = gdk_display_get_default_seat (gdk_display);
	_tmp3_ = _g_object_ref0 (_tmp2_);
	seat = _tmp3_;
	_tmp4_ = gdk_seat_get_pointer (seat);
	_tmp5_ = _g_object_ref0 (_tmp4_);
	device = _tmp5_;
	gdk_device_get_position (device, NULL, &_tmp6_, &_tmp7_);
	_vala_x = _tmp6_;
	_vala_y = _tmp7_;
	_g_object_unref0 (device);
	_g_object_unref0 (seat);
	_g_object_unref0 (gdk_display);
	if (x) {
		*x = _vala_x;
	}
	if (y) {
		*y = _vala_y;
	}
}


gboolean
utils_pointer_in_widget_area (GtkWidget* widget)
{
	gboolean result = FALSE;
	gint pointer_x = 0;
	gint pointer_y = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	GtkAllocation widget_rect = {0};
	GtkAllocation _tmp2_ = {0};
	gint window_x = 0;
	gint window_y = 0;
	GtkWidget* _tmp3_;
	GdkWindow* _tmp4_;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	gint _tmp10_;
	gint _tmp11_;
	GtkAllocation _tmp12_;
	gint _tmp13_;
	g_return_val_if_fail (widget != NULL, FALSE);
	utils_get_pointer_position (&_tmp0_, &_tmp1_);
	pointer_x = _tmp0_;
	pointer_y = _tmp1_;
	utils_get_origin_allocation (widget, &_tmp2_);
	widget_rect = _tmp2_;
	_tmp3_ = gtk_widget_get_toplevel (widget);
	_tmp4_ = gtk_widget_get_window (_tmp3_);
	gdk_window_get_root_origin (_tmp4_, &_tmp5_, &_tmp6_);
	window_x = _tmp5_;
	window_y = _tmp6_;
	_tmp10_ = pointer_x;
	_tmp11_ = window_x;
	_tmp12_ = widget_rect;
	_tmp13_ = _tmp12_.x;
	if (_tmp10_ > (_tmp11_ + _tmp13_)) {
		gint _tmp14_;
		gint _tmp15_;
		GtkAllocation _tmp16_;
		gint _tmp17_;
		GtkAllocation _tmp18_;
		gint _tmp19_;
		_tmp14_ = pointer_x;
		_tmp15_ = window_x;
		_tmp16_ = widget_rect;
		_tmp17_ = _tmp16_.x;
		_tmp18_ = widget_rect;
		_tmp19_ = _tmp18_.width;
		_tmp9_ = _tmp14_ < ((_tmp15_ + _tmp17_) + _tmp19_);
	} else {
		_tmp9_ = FALSE;
	}
	if (_tmp9_) {
		gint _tmp20_;
		gint _tmp21_;
		GtkAllocation _tmp22_;
		gint _tmp23_;
		_tmp20_ = pointer_y;
		_tmp21_ = window_y;
		_tmp22_ = widget_rect;
		_tmp23_ = _tmp22_.y;
		_tmp8_ = _tmp20_ > (_tmp21_ + _tmp23_);
	} else {
		_tmp8_ = FALSE;
	}
	if (_tmp8_) {
		gint _tmp24_;
		gint _tmp25_;
		GtkAllocation _tmp26_;
		gint _tmp27_;
		GtkAllocation _tmp28_;
		gint _tmp29_;
		_tmp24_ = pointer_y;
		_tmp25_ = window_y;
		_tmp26_ = widget_rect;
		_tmp27_ = _tmp26_.y;
		_tmp28_ = widget_rect;
		_tmp29_ = _tmp28_.height;
		_tmp7_ = _tmp24_ < ((_tmp25_ + _tmp27_) + _tmp29_);
	} else {
		_tmp7_ = FALSE;
	}
	result = _tmp7_;
	return result;
}


void
utils_show_manual (void)
{
	GError * _inner_error_ = NULL;
	if (utils_is_command_exist ("dman")) {
		{
			GAppInfo* appinfo = NULL;
			GAppInfo* _tmp0_;
			GAppInfo* _tmp1_;
			_tmp0_ = g_app_info_create_from_commandline ("dman deepin-terminal", NULL, G_APP_INFO_CREATE_NONE, &_inner_error_);
			appinfo = _tmp0_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch23_g_error;
			}
			_tmp1_ = appinfo;
			g_app_info_launch (_tmp1_, NULL, NULL, &_inner_error_);
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				_g_object_unref0 (appinfo);
				goto __catch23_g_error;
			}
			_g_object_unref0 (appinfo);
		}
		goto __finally23;
		__catch23_g_error:
		{
			GError* e = NULL;
			GError* _tmp2_;
			const gchar* _tmp3_;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp2_ = e;
			_tmp3_ = _tmp2_->message;
			g_print ("Appbar menu item 'help': %s\n", _tmp3_);
			_g_error_free0 (e);
		}
		__finally23:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


void
utils_write_log (const gchar* log)
{
	gchar* log_file_dir = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* log_file = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (log != NULL);
	_tmp0_ = g_get_user_cache_dir ();
	_tmp1_ = g_build_path (G_DIR_SEPARATOR_S, _tmp0_, "deepin", "deepin-terminal", NULL);
	log_file_dir = _tmp1_;
	_tmp2_ = g_get_user_cache_dir ();
	_tmp3_ = g_build_path (G_DIR_SEPARATOR_S, _tmp2_, "deepin", "deepin-terminal", "deepin-terminal.log", NULL);
	log_file = _tmp3_;
	utils_touch_dir (log_file_dir);
	{
		g_file_set_contents (log_file, log, (gssize) -1, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch24_g_error;
		}
	}
	goto __finally24;
	__catch24_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp4_ = e;
		_tmp5_ = _tmp4_->message;
		g_print ("write_log: %s\n", _tmp5_);
		_g_error_free0 (e);
	}
	__finally24:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_free0 (log_file);
		_g_free0 (log_file_dir);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_g_free0 (log_file);
	_g_free0 (log_file_dir);
}


cairo_surface_t*
utils_create_image_surface (const gchar* surface_path)
{
	cairo_surface_t* result = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (surface_path != NULL, NULL);
	{
		gdouble scale = 0.0;
		RsvgHandle* r = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		RsvgHandle* _tmp2_;
		RsvgHandle* _tmp3_;
		RsvgDimensionData d = {0};
		RsvgDimensionData _tmp4_ = {0};
		cairo_surface_t* cs = NULL;
		RsvgDimensionData _tmp5_;
		gint _tmp6_;
		RsvgDimensionData _tmp7_;
		gint _tmp8_;
		cairo_surface_t* _tmp9_;
		cairo_surface_t* _tmp10_;
		cairo_t* c = NULL;
		cairo_surface_t* _tmp11_;
		cairo_t* _tmp12_;
		cairo_t* _tmp13_;
		scale = utils_get_default_monitor_scale ();
		_tmp0_ = utils_get_image_path (surface_path);
		_tmp1_ = _tmp0_;
		_tmp2_ = rsvg_handle_new_from_file (_tmp1_, &_inner_error_);
		_tmp3_ = _tmp2_;
		_g_free0 (_tmp1_);
		r = _tmp3_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch25_g_error;
		}
		rsvg_handle_get_dimensions (r, &_tmp4_);
		d = _tmp4_;
		_tmp5_ = d;
		_tmp6_ = _tmp5_.width;
		_tmp7_ = d;
		_tmp8_ = _tmp7_.height;
		_tmp9_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, (gint) (_tmp6_ * scale), (gint) (_tmp8_ * scale));
		cs = _tmp9_;
		_tmp10_ = cs;
		cairo_surface_set_device_scale (_tmp10_, scale, scale);
		_tmp11_ = cs;
		_tmp12_ = cairo_create (_tmp11_);
		c = _tmp12_;
		_tmp13_ = c;
		rsvg_handle_render_cairo (r, _tmp13_);
		result = cs;
		_cairo_destroy0 (c);
		_g_object_unref0 (r);
		return result;
	}
	goto __finally25;
	__catch25_g_error:
	{
		GError* e = NULL;
		GError* _tmp14_;
		const gchar* _tmp15_;
		cairo_surface_t* cs = NULL;
		cairo_surface_t* _tmp16_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp14_ = e;
		_tmp15_ = _tmp14_->message;
		g_print ("create_image_surface: %s %s\n", surface_path, _tmp15_);
		_tmp16_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, 1, 1);
		cs = _tmp16_;
		result = cs;
		_g_error_free0 (e);
		return result;
	}
	__finally25:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
	g_clear_error (&_inner_error_);
	return NULL;
}


gint
utils_get_active_monitor (GdkScreen* screen)
{
	gint result = 0;
	GdkWindow* window = NULL;
	GdkWindow* _tmp0_;
	GdkWindow* _tmp1_;
	g_return_val_if_fail (screen != NULL, 0);
	_tmp0_ = gdk_screen_get_active_window (screen);
	window = _tmp0_;
	_tmp1_ = window;
	if (_tmp1_ != NULL) {
		GdkWindow* _tmp2_;
		_tmp2_ = window;
		result = gdk_screen_get_monitor_at_window (screen, _tmp2_);
		_g_object_unref0 (window);
		return result;
	} else {
		result = gdk_screen_get_primary_monitor (screen);
		_g_object_unref0 (window);
		return result;
	}
	_g_object_unref0 (window);
}


gdouble
utils_get_default_monitor_scale (void)
{
	gdouble result = 0.0;
	GdkDisplay* display = NULL;
	GdkDisplay* _tmp0_;
	GdkDisplay* _tmp1_;
	GdkDisplay* _tmp2_;
	_tmp0_ = gdk_display_get_default ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	display = _tmp1_;
	_tmp2_ = display;
	if (_tmp2_ != NULL) {
		GdkMonitor* monitor = NULL;
		GdkDisplay* _tmp3_;
		GdkMonitor* _tmp4_;
		GdkMonitor* _tmp5_;
		GdkMonitor* _tmp6_;
		_tmp3_ = display;
		_tmp4_ = gdk_display_get_primary_monitor (_tmp3_);
		_tmp5_ = _g_object_ref0 (_tmp4_);
		monitor = _tmp5_;
		_tmp6_ = monitor;
		if (_tmp6_ != NULL) {
			GdkMonitor* _tmp7_;
			_tmp7_ = monitor;
			result = (gdouble) gdk_monitor_get_scale_factor (_tmp7_);
			_g_object_unref0 (monitor);
			_g_object_unref0 (display);
			return result;
		}
		_g_object_unref0 (monitor);
	}
	result = 1.0;
	_g_object_unref0 (display);
	return result;
}


static gdouble
double_parse (const gchar* str)
{
	gdouble result = 0.0;
	gdouble _tmp0_;
	g_return_val_if_fail (str != NULL, 0.0);
	_tmp0_ = g_ascii_strtod (str, NULL);
	result = _tmp0_;
	return result;
}


gdouble
utils_get_dde_scale_ratio (void)
{
	gdouble result = 0.0;
	gchar* scaleStr = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gdouble parsedScale = 0.0;
	const gchar* _tmp3_;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_;
	_tmp0_ = g_getenv ("QT_SCALE_FACTOR");
	_tmp1_ = g_strdup (_tmp0_);
	scaleStr = _tmp1_;
	_tmp2_ = scaleStr;
	if (_tmp2_ == NULL) {
		result = 1.0;
		_g_free0 (scaleStr);
		return result;
	}
	_tmp3_ = scaleStr;
	parsedScale = double_parse (_tmp3_);
	_tmp5_ = parsedScale;
	if (_tmp5_ == ((gdouble) 0)) {
		_tmp4_ = 1.0;
	} else {
		gdouble _tmp6_;
		_tmp6_ = parsedScale;
		_tmp4_ = _tmp6_;
	}
	result = _tmp4_;
	_g_free0 (scaleStr);
	return result;
}


gint
utils_get_pointer_monitor (GdkScreen* screen)
{
	gint result = 0;
	gint x = 0;
	gint y = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	g_return_val_if_fail (screen != NULL, 0);
	utils_get_pointer_position (&_tmp0_, &_tmp1_);
	x = _tmp0_;
	y = _tmp1_;
	result = gdk_screen_get_monitor_at_point (screen, x, y);
	return result;
}


gchar*
utils_get_process_cmdline (gint pid)
{
	gchar* result = NULL;
	GFile* cmd_file = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	gchar* command = NULL;
	gchar* _tmp4_;
	GFile* _tmp5_;
	GError * _inner_error_ = NULL;
	_tmp0_ = g_strdup_printf ("/proc/%d/cmdline", pid);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_file_new_for_path (_tmp1_);
	_tmp3_ = _tmp2_;
	_g_free0 (_tmp1_);
	cmd_file = _tmp3_;
	_tmp4_ = g_strdup ("");
	command = _tmp4_;
	_tmp5_ = cmd_file;
	if (!g_file_query_exists (_tmp5_, NULL)) {
		result = command;
		_g_object_unref0 (cmd_file);
		return result;
	}
	{
		GFileInputStream* _tmp6_ = NULL;
		GFile* _tmp7_;
		GFileInputStream* _tmp8_;
		GDataInputStream* dis = NULL;
		GDataInputStream* _tmp9_;
		guint8* data = NULL;
		guint8* _tmp10_;
		gint data_length1;
		gint _data_size_;
		gssize size = 0L;
		GDataInputStream* _tmp11_;
		guint8* _tmp12_;
		gint _tmp12__length1;
		gssize _tmp13_;
		guint8* _tmp29_;
		gint _tmp29__length1;
		gchar* _tmp30_;
		_tmp7_ = cmd_file;
		_tmp8_ = g_file_read (_tmp7_, NULL, &_inner_error_);
		_tmp6_ = _tmp8_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch26_g_error;
		}
		_tmp9_ = g_data_input_stream_new ((GInputStream*) _tmp6_);
		dis = _tmp9_;
		_tmp10_ = g_new0 (guint8, 4097);
		data = _tmp10_;
		data_length1 = 4097;
		_data_size_ = data_length1;
		_tmp11_ = dis;
		_tmp12_ = data;
		_tmp12__length1 = data_length1;
		size = g_input_stream_read ((GInputStream*) _tmp11_, _tmp12_, (gsize) _tmp12__length1, NULL, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			data = (g_free (data), NULL);
			_g_object_unref0 (dis);
			_g_object_unref0 (_tmp6_);
			goto __catch26_g_error;
		}
		_tmp13_ = size;
		if (_tmp13_ <= ((gssize) 0)) {
			gchar* _tmp14_;
			_tmp14_ = g_strdup ("");
			_g_free0 (command);
			command = _tmp14_;
		}
		{
			gint pos = 0;
			pos = 0;
			{
				gboolean _tmp15_ = FALSE;
				_tmp15_ = TRUE;
				while (TRUE) {
					gint _tmp17_;
					gssize _tmp18_;
					gboolean _tmp19_ = FALSE;
					guint8* _tmp20_;
					gint _tmp20__length1;
					gint _tmp21_;
					guint8 _tmp22_;
					if (!_tmp15_) {
						gint _tmp16_;
						_tmp16_ = pos;
						pos = _tmp16_ + 1;
					}
					_tmp15_ = FALSE;
					_tmp17_ = pos;
					_tmp18_ = size;
					if (!(((gssize) _tmp17_) < _tmp18_)) {
						break;
					}
					_tmp20_ = data;
					_tmp20__length1 = data_length1;
					_tmp21_ = pos;
					_tmp22_ = _tmp20_[_tmp21_];
					if (_tmp22_ == ((guint8) '\0')) {
						_tmp19_ = TRUE;
					} else {
						guint8* _tmp23_;
						gint _tmp23__length1;
						gint _tmp24_;
						guint8 _tmp25_;
						_tmp23_ = data;
						_tmp23__length1 = data_length1;
						_tmp24_ = pos;
						_tmp25_ = _tmp23_[_tmp24_];
						_tmp19_ = _tmp25_ == ((guint8) '\n');
					}
					if (_tmp19_) {
						guint8* _tmp26_;
						gint _tmp26__length1;
						gint _tmp27_;
						guint8 _tmp28_;
						_tmp26_ = data;
						_tmp26__length1 = data_length1;
						_tmp27_ = pos;
						_tmp26_[_tmp27_] = (guint8) ' ';
						_tmp28_ = _tmp26_[_tmp27_];
					}
				}
			}
		}
		_tmp29_ = data;
		_tmp29__length1 = data_length1;
		_tmp30_ = g_strdup ((const gchar*) _tmp29_);
		_g_free0 (command);
		command = _tmp30_;
		data = (g_free (data), NULL);
		_g_object_unref0 (dis);
		_g_object_unref0 (_tmp6_);
	}
	goto __finally26;
	__catch26_g_error:
	{
		GError* e = NULL;
		GError* _tmp31_;
		const gchar* _tmp32_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp31_ = e;
		_tmp32_ = _tmp31_->message;
		g_warning ("utils.vala:490: %s\n", _tmp32_);
		_g_error_free0 (e);
	}
	__finally26:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_free0 (command);
		_g_object_unref0 (cmd_file);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	result = command;
	_g_object_unref0 (cmd_file);
	return result;
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



