/* xutils.c generated by valac 0.39.7, the Vala compiler
 * generated from xutils.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 4 -*-
 * -*- coding: utf-8 -*-
 *
 * Copyright (C) 2011 ~ 2017 Deepin, Inc.
 *               2011 ~ 2017 Wang Yong
 *
 * Author:     Wang Yong <wangyong@deepin.com>
 * Maintainer: Wang Yong <wangyong@deepin.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <gdk/gdkx.h>
#include <string.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <X11/Xregion.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))


extern gint xutils__NET_WM_MOVERESIZE_MOVE;
gint xutils__NET_WM_MOVERESIZE_MOVE = 8;
extern gint xutils__NET_WM_MOVERESIZE_SIZE_BOTTOM;
gint xutils__NET_WM_MOVERESIZE_SIZE_BOTTOM = 5;
extern gint xutils__NET_WM_MOVERESIZE_SIZE_BOTTOMLEFT;
gint xutils__NET_WM_MOVERESIZE_SIZE_BOTTOMLEFT = 6;
extern gint xutils__NET_WM_MOVERESIZE_SIZE_BOTTOMRIGHT;
gint xutils__NET_WM_MOVERESIZE_SIZE_BOTTOMRIGHT = 4;
extern gint xutils__NET_WM_MOVERESIZE_SIZE_LEFT;
gint xutils__NET_WM_MOVERESIZE_SIZE_LEFT = 7;
extern gint xutils__NET_WM_MOVERESIZE_SIZE_RIGHT;
gint xutils__NET_WM_MOVERESIZE_SIZE_RIGHT = 3;
extern gint xutils__NET_WM_MOVERESIZE_SIZE_TOP;
gint xutils__NET_WM_MOVERESIZE_SIZE_TOP = 1;
extern gint xutils__NET_WM_MOVERESIZE_SIZE_TOPLEFT;
gint xutils__NET_WM_MOVERESIZE_SIZE_TOPLEFT = 0;
extern gint xutils__NET_WM_MOVERESIZE_SIZE_TOPRIGHT;
gint xutils__NET_WM_MOVERESIZE_SIZE_TOPRIGHT = 2;

void xutils_seat_ungrab (void);
void xutils_move_window (GtkWidget* widget,
                         gint x,
                         gint y,
                         gint button);
void xutils_send_message (gint xid,
                          glong x,
                          glong y,
                          gint action,
                          gint button,
                          gint secret_value);
void xutils_resize_window (GtkWidget* widget,
                           gint x,
                           gint y,
                           gint button,
                           GdkCursorType cursor_type);
gint* xutils_cursor_type_to_action (GdkCursorType cursor_type);
static gint* _int_dup (gint* self);


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


void
xutils_seat_ungrab (void)
{
	GdkDisplay* gdk_display = NULL;
	GdkDisplay* _tmp0_;
	GdkDisplay* _tmp1_;
	GdkSeat* seat = NULL;
	GdkSeat* _tmp2_;
	GdkSeat* _tmp3_;
	_tmp0_ = gdk_display_get_default ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	gdk_display = _tmp1_;
	_tmp2_ = gdk_display_get_default_seat (gdk_display);
	_tmp3_ = _g_object_ref0 (_tmp2_);
	seat = _tmp3_;
	gdk_seat_ungrab (seat);
	_g_object_unref0 (seat);
	_g_object_unref0 (gdk_display);
}


void
xutils_move_window (GtkWidget* widget,
                    gint x,
                    gint y,
                    gint button)
{
	GtkWidget* _tmp0_;
	GdkWindow* _tmp1_;
	gint _tmp2_;
	g_return_if_fail (widget != NULL);
	xutils_seat_ungrab ();
	_tmp0_ = gtk_widget_get_toplevel (widget);
	_tmp1_ = gtk_widget_get_window (_tmp0_);
	_tmp2_ = xutils__NET_WM_MOVERESIZE_MOVE;
	xutils_send_message ((gint) gdk_x11_window_get_xid (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gdk_x11_window_get_type (), GdkX11Window)), (glong) x, (glong) y, _tmp2_, button, 0);
}


void
xutils_resize_window (GtkWidget* widget,
                      gint x,
                      gint y,
                      gint button,
                      GdkCursorType cursor_type)
{
	gint* action = NULL;
	gint* _tmp0_;
	gint* _tmp1_;
	g_return_if_fail (widget != NULL);
	_tmp0_ = xutils_cursor_type_to_action (cursor_type);
	action = _tmp0_;
	_tmp1_ = action;
	if (_tmp1_ != NULL) {
		GtkWidget* _tmp2_;
		GdkWindow* _tmp3_;
		gint* _tmp4_;
		xutils_seat_ungrab ();
		_tmp2_ = gtk_widget_get_toplevel (widget);
		_tmp3_ = gtk_widget_get_window (_tmp2_);
		_tmp4_ = action;
		xutils_send_message ((gint) gdk_x11_window_get_xid (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gdk_x11_window_get_type (), GdkX11Window)), (glong) x, (glong) y, *_tmp4_, button, 1);
	}
	_g_free0 (action);
}


static gint*
_int_dup (gint* self)
{
	gint* dup;
	dup = g_new0 (gint, 1);
	memcpy (dup, self, sizeof (gint));
	return dup;
}


static gpointer
__int_dup0 (gpointer self)
{
	return self ? _int_dup (self) : NULL;
}


gint*
xutils_cursor_type_to_action (GdkCursorType cursor_type)
{
	gint* result = NULL;
	if (cursor_type == GDK_TOP_LEFT_CORNER) {
		gint _tmp0_;
		gint* _tmp1_;
		_tmp0_ = xutils__NET_WM_MOVERESIZE_SIZE_TOPLEFT;
		_tmp1_ = __int_dup0 (&_tmp0_);
		result = _tmp1_;
		return result;
	} else {
		if (cursor_type == GDK_TOP_SIDE) {
			gint _tmp2_;
			gint* _tmp3_;
			_tmp2_ = xutils__NET_WM_MOVERESIZE_SIZE_TOP;
			_tmp3_ = __int_dup0 (&_tmp2_);
			result = _tmp3_;
			return result;
		} else {
			if (cursor_type == GDK_TOP_RIGHT_CORNER) {
				gint _tmp4_;
				gint* _tmp5_;
				_tmp4_ = xutils__NET_WM_MOVERESIZE_SIZE_TOPRIGHT;
				_tmp5_ = __int_dup0 (&_tmp4_);
				result = _tmp5_;
				return result;
			} else {
				if (cursor_type == GDK_RIGHT_SIDE) {
					gint _tmp6_;
					gint* _tmp7_;
					_tmp6_ = xutils__NET_WM_MOVERESIZE_SIZE_RIGHT;
					_tmp7_ = __int_dup0 (&_tmp6_);
					result = _tmp7_;
					return result;
				} else {
					if (cursor_type == GDK_BOTTOM_RIGHT_CORNER) {
						gint _tmp8_;
						gint* _tmp9_;
						_tmp8_ = xutils__NET_WM_MOVERESIZE_SIZE_BOTTOMRIGHT;
						_tmp9_ = __int_dup0 (&_tmp8_);
						result = _tmp9_;
						return result;
					} else {
						if (cursor_type == GDK_BOTTOM_SIDE) {
							gint _tmp10_;
							gint* _tmp11_;
							_tmp10_ = xutils__NET_WM_MOVERESIZE_SIZE_BOTTOM;
							_tmp11_ = __int_dup0 (&_tmp10_);
							result = _tmp11_;
							return result;
						} else {
							if (cursor_type == GDK_BOTTOM_LEFT_CORNER) {
								gint _tmp12_;
								gint* _tmp13_;
								_tmp12_ = xutils__NET_WM_MOVERESIZE_SIZE_BOTTOMLEFT;
								_tmp13_ = __int_dup0 (&_tmp12_);
								result = _tmp13_;
								return result;
							} else {
								if (cursor_type == GDK_LEFT_SIDE) {
									gint _tmp14_;
									gint* _tmp15_;
									_tmp14_ = xutils__NET_WM_MOVERESIZE_SIZE_LEFT;
									_tmp15_ = __int_dup0 (&_tmp14_);
									result = _tmp15_;
									return result;
								}
							}
						}
					}
				}
			}
		}
	}
	result = NULL;
	return result;
}


void
xutils_send_message (gint xid,
                     glong x,
                     glong y,
                     gint action,
                     gint button,
                     gint secret_value)
{
	Display* display = NULL;
	Display* _tmp0_;
	Window xrootwindow = 0;
	XEvent event = {0};
	glong _tmp1_;
	glong _tmp2_;
	glong _tmp3_;
	glong _tmp4_;
	glong _tmp5_;
	_tmp0_ = gdk_x11_get_default_xdisplay ();
	display = _tmp0_;
	xrootwindow = XRootWindow (display, 0);
	memset (&event, 0, sizeof (XEvent));
	event.xclient.type = (gint) ClientMessage;
	event.xclient.message_type = gdk_x11_get_xatom_by_name ("_NET_WM_MOVERESIZE");
	event.xclient.display = display;
	event.xclient.window = (Window) xid;
	event.xclient.format = 32;
	event.xclient.data.l[0] = x;
	_tmp1_ = event.xclient.data.l[0];
	event.xclient.data.l[1] = y;
	_tmp2_ = event.xclient.data.l[1];
	event.xclient.data.l[2] = (glong) action;
	_tmp3_ = event.xclient.data.l[2];
	event.xclient.data.l[3] = (glong) button;
	_tmp4_ = event.xclient.data.l[3];
	event.xclient.data.l[4] = (glong) secret_value;
	_tmp5_ = event.xclient.data.l[4];
	XSendEvent (display, xrootwindow, FALSE, (glong) (SubstructureNotifyMask | SubstructureRedirectMask), &event);
	XFlush (display);
}



